Bug 396921 - gcc 4.1.2 produces bad code
gcc 4.1.2 produces bad code
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
7
i686 Linux
low Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-11-23 10:36 EST by Antti Honkela
Modified: 2008-06-16 22:53 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-06-16 22:53:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
First demonstration file (110.21 KB, text/x-csrc)
2007-11-23 10:36 EST, Antti Honkela
no flags Details
Second demonstration file (963 bytes, text/x-csrc)
2007-11-23 10:37 EST, Antti Honkela
no flags Details

  None (edit)
Description Antti Honkela 2007-11-23 10:36:58 EST
Description of problem:
Gcc creates invalid code from the attached files by essentially trying to
dereference an integer as if it were a pointer:

        movl    nonlin@GOT(%ebx), %edi  #,
        movl    nlin@GOT(%ebx), %esi    #,
        movl    gradf@GOT(%ebx), %edx   #, tmp1129
        movl    (%ecx), %ecx    # o8opti_yx,
        movl    $1, -64(%ebp)   #, i.5726
        movl    (%esi), %eax    # nlin, nlin
        movl    gres@GOT(%ebx), %esi    #,
        movl    %ecx, -168(%ebp)        #,
        movl    (%edi), %ecx    # nonlin,
        movl    n@GOT(%ebx), %edi       #,
        movl    (%edx), %edx    # gradf,
        movl    (%esi), %esi    # gres,
        addl    %eax, %ecx      # nlin,
        movl    (%edi), %edi    # n,
        movl    %ecx, -172(%ebp)        #,
        movl    %esi, -260(%ebp)        #,
        movl    %edx, -264(%ebp)        #,
        addl    (%edi), %eax    # nonlin, nlin

The last line here causes a segmentation fault. The bug only shows up with -fPIC
-O2 (or higher).

Version-Release number of selected component (if applicable):


How reproducible:
On suitable code always, but very sensitive to global characteristics of the code.

Steps to Reproduce:
1. Compile the attached files using
  gcc -g -Wall -fPIC -O2 f1.c f2.c
2. Run the resulting a.out (optionally under gdb)
  
Actual results:
Segmentation fault on line 974 of f1.c, which is:
  for (i = 1 ; i <= n ; i++) 

Expected results:
Program runs without problems

Additional info:
The test case is rather long, because the bug is very evasive. Even removing
code long after the affected location will often make the bug disappear.
Comment 1 Antti Honkela 2007-11-23 10:36:58 EST
Created attachment 267611 [details]
First demonstration file
Comment 2 Antti Honkela 2007-11-23 10:37:56 EST
Created attachment 267621 [details]
Second demonstration file
Comment 3 Bug Zapper 2008-05-14 11:06:15 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2008-06-16 22:53:23 EDT
Fedora 7 changed to end-of-life (EOL) status on June 13, 2008. 
Fedora 7 is no longer maintained, which means that it will not 
receive any further security or bug fix updates. As a result we 
are closing this bug. 

If you can reproduce this bug against a currently maintained version 
of Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.